package org.sc3d.apt.jrider.v1;

/** Describes a cross-section through a road. Cambers are used to draw the road in the first place, and also to define the course that the players must complete each lap. */
public class Camber {
  /** A coordinate of the point in the middle of the road. */
  public int x, y, z;
  
  /** A component of the vector from the middle to the right-hand side of the road, defining its width, direction and camber. */
  public int xx, xy, xz;
  
  /** 'true' if the road should have a barrier on one side. */
  public boolean barrierLeft, barrierRight;
}
